TTUFNFApp = {
    prepareForAppReady : function () {
        this.setupFNF.init();
    },
    
    setupFNF : {
        
        init : function () {
            
            if (!FNF.native) {
                FNF.native = {};
            }
            
            FNF.native.supportsRefundTransfer = false;
            FNF.native.supportsRefundBonus = false;
            FNF.native.platform = "IOS";
            
            if (!FNF.native.interface) {
                FNF.native.interface = {};
            }
            
            // Injected cart filter function
            FNF.native.interface.updateCartModel = function(cartModel) {
                var action = 'updateCartModel';
                window.location = 'ttu://fnf?action=' + action + '&data=' + encodeURIComponent(cartModel);
            };
            
            FNF.native.interface.purchaseItems = function() {
                var action = 'purchaseItems';
                window.location = 'ttu://fnf?action=' + action;
            };
            FNF.native.interface.consumeItems = function(items) {
                var action = 'consumeItems';
                window.location = 'ttu://fnf?action=' + action + '&data=' + encodeURIComponent(items);
            }
            FNF.native.interface.getNativePrices = function() {
                var action = 'getNativePrices';
                window.location = 'ttu://fnf?action=' + action;
            }
        }
    },
    
    functions : {
        
        handleUpdateCartModel : function (status, cartModel) {
            if (FNF.native && FNF.native.interface && FNF.native.interface.handleUpdateCartModel && _.isFunction(FNF.native.interface.handleUpdateCartModel)) {
                FNF.native.interface.handleUpdateCartModel(status , cartModel);
            }
        },
        
        handlePurchaseItems : function(status, items) {
            if(FNF.native && FNF.native.interface && FNF.native.interface.handlePurchaseItems && _.isFunction(FNF.native.interface.handlePurchaseItems)) {
                FNF.native.interface.handlePurchaseItems(status, items);
            }
        },
        
        handleConsumeItems : function(status) {
            if(FNF.native && FNF.native.interface && FNF.native.interface.handleConsumeItems && _.isFunction(FNF.native.interface.handleConsumeItems)) {
                FNF.native.interface.handleConsumeItems(status);
            }
        },

        handleGetNativePrices : function(jsonPrices) {
            if(FNF.native && FNF.native.interface && FNF.native.interface.handleGetNativePrices && _.isFunction(FNF.native.interface.handleGetNativePrices)) {
                FNF.native.interface.handleGetNativePrices("OK", jsonPrices);
            }
        },
        
        testUpdateCartMethod : function() {
            alert('Smoke Test');
            var str = '{ "StatusResponse": { "status": "SUCCESS" }, "ShoppingCartModel": { "empty": false, "total": "134.97", "hasAD": true, "hasRT": false, "hasADLifetime": false, "hasADSubscription": false, "showFootNotes": false, "shoppingCartItems": [{ "benefitType": "STATE", "displayName": "TurboTax State: Arizona", "prodId": "16", "formsetId": "S2013ZAZ", "itemType": "FeePrep", "strikeThroughPrice": "39.99", "remainingBalance": "39.99", "stateName": "Arizona", "removable": false, "showDiscountedMsg": false },{ "benefitType": "STATE", "displayName": "TurboTax State: NY", "prodId": "16", "formsetId": "S2013ZAZ", "itemType": "FeePrep", "strikeThroughPrice": "39.99", "remainingBalance": "39.99", "stateName": "New York", "removable": false, "showDiscountedMsg": false }, { "benefitType": "FED", "displayName": "TurboTax Online - Deluxe", "prodId": "16", "formsetId": "S2013US1040PER", "itemType": "FeePrep", "strikeThroughPrice": "49.99", "remainingBalance": "49.99", "removable": false, "showDiscountedMsg": false }, { "benefitType": "AD", "displayName": "Audit Defense", "prodId": "16", "formsetId": "SvcAuditDefense", "itemType": "1040_State", "strikeThroughPrice": "44.99", "remainingBalance": "44.99", "removable": true, "showDiscountedMsg": false }] }, "PurchaseModel": { "showADOffer": false, "showRTOffer": true } }';
            var sampleCart = JSON.stringify(eval("(" + str + ")"));
            FNF.native.interface.updateCartModel(sampleCart);
        },
        
        testExternalPricesMethod : function() {
            alert('Smoke Test');
            FNF.native.interface.getNativePrices();
        }
    }
};

var FNF = FNF || {};

TTUFNFApp.prepareForAppReady();