PonHelp = {
    showUI : function (helpContent, shouldEmbedIntoTemplate) {
       
        if(shouldEmbedIntoTemplate===true) {
            // Embed the html
            this.embedHelpContent(helpContent);
        } else {
            // no need to embed; just customize the UI
            this.customizeHelpContent(helpContent);
        }
        
        // Add handlers for hyperlinks so that we can route it back to native code
        var hrefTags = document.getElementsByTagName('a');
        for(var i = 0; i < hrefTags.length; i++) {
            
            var link = hrefTags[i];
            // Apply style to link (TTO's javascript replaces <a href=""> with <button class="ponHyperButton">)
            link.className = link.className + " ponHyperButton";
            
            // Hide link 'Back to Top'
            if(link.text.toLowerCase() == 'back to top') {
                link.style.display = 'none';
            }
            link.onclick = function(){
                var matches = new RegExp("hyperTo\\('(.*)'\\).*").exec(this.href)
                if(matches != null && matches.length > 0) {
                    window.location = 'ttu://externalLink?helpLinkId=' + encodeURIComponent(matches[1]);
                    return;
                }
                var matches = new RegExp("hyperToUrl\\('(.*)'\\).*").exec(link)
                if(matches != null && matches.length > 0) {
                    window.location = 'ttu://externalLink?URL=' + encodeURIComponent(matches[1]);
                    return;
                }
            }
        }
    },
    
    embedHelpContent: function (helpContent){
        // Embed the help content in the current view
        // Parse the helpContent and format it so suit TTU style
        var contentParsingRegex = "<TITLE>(.*)<\/TITLE>.*<BODY.*>(<H1>.*<\/H1>)(.*)<\/BODY>";
        var matches = new RegExp(contentParsingRegex).exec(helpContent);
        if(matches != null && matches.length > 2) {
            // This is regular TTO Pon content; so read the title and put on top, hide the H1 and take just the main content
            var title = matches[1];
            var mainContent = (matches[3] != null) ? matches[3] : matches[2];
            document.getElementById('ponMainWindow').innerHTML = mainContent;
            document.getElementById('ponHeadline').innerText = title;
        } else {
            // Could not find the title and H1 header; maybe the content is not the standard TTO PoN
            //  We will just render the full content as is
            document.getElementById('ponMainWindow').innerHTML = helpContent;
        }
    },
    
    customizeHelpContent : function (helpContent) {
        
        document.getElementById('ponDragHandle').style.display='none';
        document.getElementById('ponBottomController').style.display='none';
        
        // Override the top.hyperTo functions defined for <button class='ponHyperButton'>
        //  these come in to play when there are PoN links in MojoPlayer rendered as fallback of TTO Player
        //  (eg: Were You Married)
        var hrefTags = document.getElementsByClassName('ponHyperButton');
        for(var i = 0; i < hrefTags.length; i++) {
            
            var link = hrefTags[i];

            link.onclick = function(){
                var matches = new RegExp("hyperTo\\('(.*)'\\).*").exec(this.href)
                if(matches != null && matches.length > 0) {
                    window.location = 'ttu://externalLink?helpLinkId=' + encodeURIComponent(matches[1]);
                    return;
                }
                var matches = new RegExp("hyperToUrl\\('(.*)'\\).*").exec(link)
                if(matches != null && matches.length > 0) {
                    window.location = 'ttu://externalLink?URL=' + encodeURIComponent(matches[1]);
                    return;
                }
            }
        }
    },

};
